<?php
/*
 * Copyright (c) 2025 AltumCode (https://altumcode.com/)
 *
 * This software is licensed exclusively by AltumCode and is sold only via https://altumcode.com/.
 * Unauthorized distribution, modification, or use of this software without a valid license is not permitted and may be subject to applicable legal actions.
 *
 * 🌍 View all other existing AltumCode projects via https://altumcode.com/
 * 📧 Get in touch for support or general queries via https://altumcode.com/contact
 * 📤 Download the latest version via https://altumcode.com/downloads
 *
 * 🐦 X/Twitter: https://x.com/AltumCode
 * 📘 Facebook: https://facebook.com/altumcode
 * 📸 Instagram: https://instagram.com/altumcode
 */

namespace Altum\Models;

defined('ALTUMCODE') || die();

class ItemVariants extends Model {

    public function get_item_variant_by_store_id_and_item_variant_id($store_id, $item_variant_id) {

        /* Get the item */
        $item = null;

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('s_item_variant?store_id=' . $store_id . '&item_variant_id=' . $item_variant_id);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $item = database()->query("SELECT * FROM `items_variants` WHERE `store_id` = {$store_id} AND `item_variant_id` = '{$item_variant_id}'")->fetch_object() ?? null;

            cache()->save(
                $cache_instance->set($item)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $item = $cache_instance->get();

        }

        return $item;

    }

    public function get_item_variants_by_store_id_and_item_id($store_id, $item_id) {

        /* Get the item variants */
        $item_variants = [];

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('s_item_variants?store_id=' . $store_id . '&item_id=' . $item_id);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $item_variants_result = database()->query("
                SELECT 
                    *
                FROM 
                    `items_variants` 
                WHERE 
                    `item_id` = {$item_id} 
            ");
            while($row = $item_variants_result->fetch_object()) $item_variants[] = $row;

            cache()->save(
                $cache_instance->set($item_variants)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $item_variants = $cache_instance->get();

        }

        return $item_variants;

    }

}
